//--- Robotic Hand     0..................Miller 1/15/92

//  Original file by Mike Miller
//
//  Modified for POV-Ray version 3.x by
//  Colin Fleming, cj_fleming@btinternet.com
//

//+++++++++++++++++++++++++++++++++++

#declare Dot = quadric { <1, 1, 1>, <0, 0, 0>, <0, 0, 0>, -1 }

#declare Connector_1 = 
object {
	quadric { <0, 1, 1>, <0, 0, 0>, <0, 0, 0>, -1 }
	clipped_by {
		plane { < 1, 0, 0>, 1 }
		plane { <-1, 0, 0>, 0 }
	}
}

#declare Connector_2 =
object {
	quadric { <1, -1, 1>, <0, 0, 0>, <0, 0, 0>, 0 }
	rotate z*90
}

#declare Connector_3 = 
intersection {
	quadric { <0, 1, 1>, <0, 0, 0>, <0, 0, 0>, -1 }
	plane { < 1, 0, 0>, 1 }
	plane { <-1, 0, 0>, 0 }
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++

//-- Top Digit
#declare  D1 =
union {
	object { Dot scale <8.6, 8.6, 8.6> }
	intersection {
		object { Connector_2 }
		plane { <1, 0, 0>, 8.576622 }
		plane { <1, 0, 0>, 7.180428 inverse }
		translate <-8.576622, 0, 0>
		scale <13.534536, 1, 1>
		translate <-0.633684, 0, 0>
		rotate <0, 180, 0>
		rotate <0, 0, 90>
	}
	object { Dot scale <7.2, 7.2, 7.2> translate <0, 19, 0> }
	texture { HandTexture }
	bounded_by { object { Dot scale <23.352148, 23.352148, 23.352148> translate <0, 8.8, 0> } } 
}

//--- Middle Digit
#declare D2 =
union {  
	object { Dot scale <9.8, 9.8, 9.8> }
	intersection {
		object { Connector_2 }
		plane { <1, 0, 0>, 9.787105 }
		plane { <1, 0, 0>, 8.588684 inverse }
		translate <-9.787105, 0, 0>
		scale <19.474342, 1, 1>
		translate <-0.502564, 0, 0>
		rotate <0, 180, 0>
		rotate <0, 0, 90>
	}
	object { Dot scale <8.6, 8.6, 8.6> translate <0, 23.4, 0> }
	texture { HandTexture }
	bounded_by { object { Dot scale <27.585447, 27.585447, 27.585447> translate <0, 11.1, 0> } } 
}

//--- Lower Digit
#declare D3 =
union {
	object { Dot scale <11.4, 11.4, 11.4> }
	intersection {
		object { Connector_2 }
		plane { <1, 0, 0>, 11.383989 }
		plane { <1, 0, 0>, 9.786237 inverse }
		translate <-11.383989, 0, 0>
		scale <18.848491, 1, 1>
		translate <-0.603974, 0, 0>
		rotate <0, 180, 0>
		rotate <0, 0, 90>
	}
	object { Dot scale <9.8, 9.8, 9.8> translate <0, 30.2, 0> }
	texture { HandTexture }
	bounded_by { object { Dot scale <33.372086, 33.372086, 33.372086> translate <0, 14.3, 0> } } 
}

//--- Base Thumb
#declare T1 =
union {
	object { Dot scale <22.2, 22.2, 22.2> }
	intersection {
		object { Connector_2 }
		plane { <1, 0, 0>, 21.677773 }
		plane { <1, 0, 0>, 14.940087 inverse }
		translate <-21.677773, 0, 0>
		scale <4.528585, 1, 1>
		translate <-4.786875, 0, 0>
		rotate <0, 180, 0>
		rotate <0, 0, 90>
	}
	object { Dot scale <15.3, 15.3, 15.3> translate <0, 32, 0> }
	texture { HandTexture }
	bounded_by { object { Dot scale <51.515274, 51.515274, 51.515274> translate <0, 12.55, 0> } }
	scale <0.8, 1, 0.8>
}

//--- Mid Thumb
#declare T2 =
union {
	object { Dot scale <15.3, 15.3, 15.3> }
	intersection { 
		object { Connector_2 }
		plane { <1, 0, 0>, 14.676853 }
		plane { <1, 0, 0>, 9.880496 inverse }
		translate <-14.676853, 0, 0>
		scale <3.395821, 1, 1>
		translate <-4.322034, 0, 0>
		rotate <0, 180, 0>
		rotate <0, 0, 90>
	}
	object { Dot scale <10.3, 10.3, 10.3> translate <0, 17.7, 0> }
	texture { HandTexture }
	bounded_by { object { Dot scale <33.669749, 33.669749, 33.669749> translate <0, 6.35, 0> } }
	scale <0.8, 1, 0.8>
}

//--- Thumb Tip
#declare T3 =
union {
	object { Dot scale <10.3, 10.3, 10.3> }
	intersection {
		object { Connector_2 }
		plane { <1, 0, 0>, 10.18827 }
		plane { <1, 0, 0>, 7.616474 inverse }
		translate <-10.18827, 0, 0>
		scale <6.733845, 1, 1>
		translate <-1.512994, 0, 0>
		rotate <0, 180, 0>
		rotate <0, 0, 90>
	}
	object { Dot scale <7.7, 7.7, 7.7> translate <0, 17.7, 0> }
	texture { HandTexture }
	bounded_by { object { Dot scale <25.343067, 25.343067, 25.343067> translate <0, 7.55, 0> } }
	scale <0.8, 1, 0.8>
}

#declare Palm =
difference {
	union {
		object { Dot scale <31, 31, 31> translate <20.4, 28.8, 0> }
		object { Connector_3 scale <40.2, 31, 31> rotate <0, -180, 0> translate <20.4, 28.8, 6>  }
		object { Dot scale <31, 31, 31> translate <-19.8, 28.8, 0> }
		object { Connector_3 scale <32.846918, 31, 31> rotate <0, 0, 80.537678> translate <-19.8, 28.8, 0> } 
		object { Dot scale <31, 31, 31> translate <-14.4, 61.2, 0> }
		object { Connector_3 scale <32.975749, 31, 31> rotate <0, 0, 5.91806> translate <-14.4, 61.2, 5> }
		object { Dot scale <31, 31, 31> translate <18.4, 64.6, 0> }
	}
	//quadric { <0, 1, 1>, <0, 0, 0>, <0, 0, 0>, -1
	object {
		Cylinder_X
		scale <1, 52, 32> translate <0, 45.8, -4.6> inverse }
	texture { HandTexture }
	bounded_by { object { Dot scale <84.945501, 84.945501, 84.945501> translate <0.3, 46.7, 0> } }
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//--- Complete Right Hand
#declare RightHand =
union {

	//--- First Finger
	union {
		object { D3 }
		union {
			object { D2 }
			object { D1 
				rotate <-30, 0, 0>       //-- Rotates Finger tip 
				translate <0, 23.4, 0> 
			}
			rotate <-30, 0, 0>         //-- Rotates Middle digit
			translate <0, 30.2, 0>
		}
		scale <0.8, 0.8, 0.8>              //-- Sizes Finger 
		rotate <-15, 0, 0>              //-- Rotates Whole Finger inward
		rotate <0, 0, 14>               //-- Rotates Whole Finger "Fan"
		translate <-35, 85.8, 0>        //-- Moves Finger over
	}

	//--- Second Finger
	union {
		object { D3 }
		union {
			object { D2 }
			object { D1 
				rotate <-20, 0, 0>       //-- Rotates Finger tip 
				translate <0, 23.4, 0> 
			}
			rotate <-20, 0, 0>         //-- Rotates Middle digit
			translate <0, 30.2, 0>
		}
		scale <0.9, 0.9, 0.9>                //-- Sizes Finger 
		rotate <-10, 0, 0>              //-- Rotates Whole Finger inward
		rotate <0, 0, 7>               //-- Rotates Whole Finger "Fan"
		translate <-13.3, 90.7, 0>            //-- Moves Finger over
	}

	//--- Third Bird Finger
	union {
		object { D3 }
		union {
			object { D2 }
			object { D1 
				rotate <-10, 0, 0>       //-- Rotates Finger tip 
				translate <0, 23.4, 0> 
			}
			rotate <-10, 0, 0>         //-- Rotates Middle digit
			translate <0, 30.2, 0>
		}
		scale <1, 1, 1>                //-- Sizes Finger 
		rotate <-5, 0, 0>              //-- Rotates Whole Finger inward
		rotate <0, 0, 0>               //-- Rotates Whole Finger "Fan"
		translate <11.4, 91.1, 0>            //-- Moves Finger over
	}

	//--- Fourth Finger
	union {
		object { D3 }
		union {
			object { D2 }
			object { D1 
				rotate <-40, 0, 0>       //-- Rotates Finger tip 
				translate <0, 23.4, 0> 
			}
			rotate <-20, 0, 0>         //-- Rotates Middle digit
			translate <0, 30.2, 0>
		}
		scale <0.9, 0.9, 0.9>              //-- Sizes Finger 
		rotate <-15, 0, 0>              //-- Rotates Whole Finger inward
		rotate <0, 0, -7>               //-- Rotates Whole Finger "Fan"
		translate <34.7, 87.8, 0>       //-- Moves Finger over
	}

	//--- Thumb
	union {
		object { T1 }
		union { 
			object { T2 }
			object { T3
				rotate <0, 0, 40>          //--- Rotates Thumb Tip inward   
				translate <0, 17.7, 0>
			}
			rotate <0, 0, 10>             //--- Rotate Mid Thumb inward
			translate <0, 32, 0>
		}
		scale <1, 1, 0.9>
		rotate <0, 0, -40>           //--- Rotate Whole Thumb   
		rotate <0, 30, 0>
		translate <40, 20.1, 0>
	}

	object { Palm scale <1, 1, 0.6> }

	object {
		union {
			object { Dot scale <10, 10, 5> translate <-33,   76, 9> }
			object { Dot scale <10, 10, 5> translate <-13.3, 83, 9> }
			object { Dot scale <10, 10, 5> translate < 11.4, 84, 9> }
			object { Dot scale <10, 10, 5> translate < 34.7, 80, 9> }
		}
		texture { HandTexture }
	}
	bounded_by { object { Dot scale <103, 103, 103> translate <0, 80, 0> } }
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//--- Complete Left Hand
#declare LeftHand =
union {

	//--- First Finger
	union {
		object { D3 }
		union {
			object { D2 }
			object { D1 
				rotate <-30, 0, 0>       //-- Rotates Finger tip 
				translate <0, 23.4, 0> 
			}
			rotate <-30, 0, 0>         //-- Rotates Middle digit
			translate <0, 30.2, 0>
		}
		scale <0.8, 0.8, 0.8>              //-- Sizes Finger 
		rotate <-15, 0, 0>              //-- Rotates Whole Finger inward
		rotate <0, 0, -14>               //-- Rotates Whole Finger "Fan"
		translate <35, 85.8, 0>        //-- Moves Finger over
	}

	//--- Second Finger
	union {
		object { D3 }
		union {
			object { D2 }
			object { D1 
				rotate <-20, 0, 0>       //-- Rotates Finger tip 
				translate <0, 23.4, 0> 
			}
			rotate <-20, 0, 0>         //-- Rotates Middle digit
			translate <0, 30.2, 0>
		}
		scale <0.9, 0.9, 0.9>                //-- Sizes Finger 
		rotate <-10, 0, 0>              //-- Rotates Whole Finger inward
		rotate <0, 0, -7>               //-- Rotates Whole Finger "Fan"
		translate <13.3, 90.7, 0>            //-- Moves Finger over
	}

	//--- Third Bird Finger
	union {
		object { D3 }
		union {
			object { D2 }
			object { D1 
				rotate <-10, 0, 0>       //-- Rotates Finger tip 
				translate <0, 23.4, 0> 
			}
			rotate <-10, 0, 0>         //-- Rotates Middle digit
			translate <0, 30.2, 0>
		}
		scale <1, 1, 1>                //-- Sizes Finger 
		rotate <-5, 0, 0>              //-- Rotates Whole Finger inward
		rotate <0, 0, 0>               //-- Rotates Whole Finger "Fan"
		translate <-11.4, 91.1, 0>            //-- Moves Finger over
	}

	//--- Fourth Finger
	union {
		object { D3 }
		union {
			object { D2 }
			object { D1 
				rotate <-40, 0, 0>       //-- Rotates Finger tip 
				translate <0, 23.4, 0> 
			}
			rotate <-20, 0, 0>         //-- Rotates Middle digit
			translate <0, 30.2, 0>
		}
		scale <0.9, 0.9, 0.9>              //-- Sizes Finger 
		rotate <-15, 0, 0>              //-- Rotates Whole Finger inward
		rotate <0, 0, 7>               //-- Rotates Whole Finger "Fan"
		translate <-34.7, 87.8, 0>       //-- Moves Finger over
	}

	//--- Thumb
	union {
		object { T1 }
		union { 
			object { T2 }
			object { T3
				rotate <0, 0, 40>          //--- Rotates Thumb Tip inward   
				translate <0, 17.7, 0>
			}
			rotate <0, 0, 10>             //--- Rotate Mid Thumb inward
			translate <0, 32, 0>
		}
		rotate <0, 150, 0>
		scale <1, 1, 0.9>
		rotate <0, 0, 40>           //--- Rotate Whole Thumb   
		translate <-40, 20.1, 0>
	}

	object { Palm  scale <1, 1, 0.6> }

	object {
		union {
			object { Dot scale <10, 10, 5> translate < 33,   76, 9> }
			object { Dot scale <10, 10, 5> translate < 13.3, 83, 9> }
			object { Dot scale <10, 10, 5> translate <-11.4, 84, 9> }
			object { Dot scale <10, 10, 5> translate <-34.7, 80, 9> }
		}
		texture { HandTexture }
	}
	bounded_by { object { Dot scale <103, 103, 103> translate <0, 80, 0> } }
}



//--- Hey Joe, where you going with that gun in your hand?
#declare GunHand =
union {

	union {
	
		//--- First Finger
		union {
			object { D3 }
			union {
				object { D2 }
				object { D1 
					rotate <-70, 0, 0>       //-- Rotates Finger tip 
					translate <0, 23.4, 0> 
				}
				rotate <-70, 0, 0>         //-- Rotates Middle digit
				translate <0, 30.2, 0>
			}
			scale <0.8, 0.8, 0.8>              //-- Sizes Finger 
			rotate <-25, 0, 0>              //-- Rotates Whole Finger inward
			rotate <0, 0, -14>               //-- Rotates Whole Finger "Fan"
			translate <35, 85.8, 0>        //-- Moves Finger over
		}

		//--- Second Finger
		union {
			object { D3 }
			union {
				object { D2 }
				object { D1 
					rotate <-70, 0, 0>       //-- Rotates Finger tip 
					translate <0, 23.4, 0> 
				}
				rotate <-70, 0, 0>         //-- Rotates Middle digit
				translate <0, 30.2, 0>
			}
			scale <0.9, 0.9, 0.9>                //-- Sizes Finger 
			rotate <-25, 0, 0>              //-- Rotates Whole Finger inward
			rotate <0, 0, -7>               //-- Rotates Whole Finger "Fan"
			translate <13.3, 90.7, 0>            //-- Moves Finger over
		}

		//--- Third Bird Finger
		union {
			object { D3 }
			union {
				object { D2 }
				object { D1 
					rotate <-70, 0, 0>       //-- Rotates Finger tip 
					translate <0, 23.4, 0> 
				}
				rotate <-70, 0, 0>         //-- Rotates Middle digit
				translate <0, 30.2, 0>
			}
			scale <1, 1, 1>                //-- Sizes Finger 
			rotate <-25, 0, 0>              //-- Rotates Whole Finger inward
			rotate <0, 0, 0>               //-- Rotates Whole Finger "Fan"
			translate <-11.4, 91.1, 0>            //-- Moves Finger over
		}

		//--- Fourth Finger
		union {
			object { D3 }
			union {
				object { D2 }
				object { D1 
					rotate <-40, 0, 0>       //-- Rotates Finger tip 
					translate <0, 23.4, 0> 
				}
				rotate <-20, 0, 0>         //-- Rotates Middle digit
				translate <0, 30.2, 0>
			}
			scale <0.9, 0.9, 0.9>              //-- Sizes Finger 
			rotate <-15, 0, 0>              //-- Rotates Whole Finger inward
			rotate <0, 0, 7>               //-- Rotates Whole Finger "Fan"
			translate <-34.7, 87.8, 0>       //-- Moves Finger over
		}

		//--- Thumb
		union {
			object { T1 }
			union { 
				object { T2 }
				object { T3
					rotate <0, 0, 40>          //--- Rotates Thumb Tip inward   
					translate <0, 17.7, 0>
				}
				rotate <0, 0, 10>             //--- Rotate Mid Thumb inward
				translate <0, 32, 0>
			}
			rotate <0, 90, 0>
			scale <1, 1, 0.9>
			rotate <0, 0, 5>           //--- Rotate Whole Thumb   
			rotate <-40, 0, 0>
			translate <-40, 20.1, -2>
		}

		object { Palm  scale <1, 1, 0.6> }

		object {
			union {
				object { Dot scale <10, 10, 5> translate < 33,   76, 9> }
				object { Dot scale <10, 10, 5> translate < 13.3, 83, 9> }
				object { Dot scale <10, 10, 5> translate <-11.4, 84, 9> }
				object { Dot scale <10, 10, 5> translate <-34.7, 80, 9> }
			}
			texture { HandTexture }
		}
		bounded_by { object { Dot scale <103, 103, 103> translate <0, 80, 0> } }
		scale <0.35, 0.35, 0.35>
	}

    object {
		RayGun
		scale <0.9, 0.9, 0.9>
		rotate <0, 0, -90>
		rotate <0, 180, 0>
		translate <-5, 28, -6>
	}
}

//--- Hand with Gun but no bullets
#declare GunHand_N =
union {

	union {

		//--- First Finger
		union {
			object { D3 }
			union {
				object { D2 }
				object { D1 
					rotate <-70, 0, 0>       //-- Rotates Finger tip 
					translate <0, 23.4, 0> 
				}
				rotate <-70, 0, 0>         //-- Rotates Middle digit
				translate <0, 30.2, 0>
			}
			scale <0.8, 0.8, 0.8>              //-- Sizes Finger 
			rotate <-25, 0, 0>              //-- Rotates Whole Finger inward
			rotate <0, 0, -14>               //-- Rotates Whole Finger "Fan"
			translate <35, 85.8, 0>        //-- Moves Finger over
		}

		//--- Second Finger
		union {
			object { D3 }
			union {
				object { D2 }
				object { D1 
					rotate <-70, 0, 0>       //-- Rotates Finger tip 
					translate <0, 23.4, 0> 
				}
				rotate <-70, 0, 0>         //-- Rotates Middle digit
				translate <0, 30.2, 0>
			}
			scale <0.9, 0.9, 0.9>                //-- Sizes Finger 
			rotate <-25, 0, 0>              //-- Rotates Whole Finger inward
			rotate <0, 0, -7>               //-- Rotates Whole Finger "Fan"
			translate <13.3, 90.7, 0>            //-- Moves Finger over
		}

		//--- Third Bird Finger
		union {
			object { D3 }
			union {
				object { D2 }
				object { D1 
					rotate <-70, 0, 0>       //-- Rotates Finger tip 
					translate <0, 23.4, 0> 
				}
				rotate <-70, 0, 0>         //-- Rotates Middle digit
				translate <0, 30.2, 0>
			}
			scale <1, 1, 1>                //-- Sizes Finger 
			rotate <-25, 0, 0>              //-- Rotates Whole Finger inward
			rotate <0, 0, 0>               //-- Rotates Whole Finger "Fan"
			translate <-11.4, 91.1, 0>            //-- Moves Finger over
		}

		//--- Fourth Finger
		union {
			object { D3 }
			union {
				object { D2 }
				object { D1 
					rotate <-40, 0, 0>       //-- Rotates Finger tip 
					translate <0, 23.4, 0> 
				}
				rotate <-20, 0, 0>         //-- Rotates Middle digit
				translate <0, 30.2, 0>
			}
			scale <0.9, 0.9, 0.9>              //-- Sizes Finger 
			rotate <-15, 0, 0>              //-- Rotates Whole Finger inward
			rotate <0, 0, 7>               //-- Rotates Whole Finger "Fan"
			translate <-34.7, 87.8, 0>       //-- Moves Finger over
		}

		//--- Thumb
		union {
			object { T1 }
			union { 
				object { T2 }
				object { T3
					rotate <0, 0, 40>          //--- Rotates Thumb Tip inward   
					translate <0, 17.7, 0>
				}
				rotate <0, 0, 10>             //--- Rotate Mid Thumb inward
				translate <0, 32, 0>
			}
			rotate <0, 90, 0>
			scale <1, 1, 0.9>
			rotate <0, 0, 5>           //--- Rotate Whole Thumb   
			rotate <-40, 0, 0>
			translate <-40, 20.1, -2>
		}

		object { Palm  scale <1, 1, 0.6> }

		object {
			union {
				object { Dot scale <10, 10, 5> translate < 33,   76, 9> }
				object { Dot scale <10, 10, 5> translate < 13.3, 83, 9> }
				object { Dot scale <10, 10, 5> translate <-11.4, 84, 9> }
				object { Dot scale <10, 10, 5> translate <-34.7, 80, 9> }
			}
			texture { HandTexture }
		}
		bounded_by { object { Dot scale <103, 103, 103> translate <0, 80, 0> } }
		scale <0.35, 0.35, 0.35>
	}

	object {
		Gun
		scale <0.9, 0.9, 0.9>
		rotate <0, 0, -90>
		rotate <0, 180, 0>
		translate <-5, 28, -6>
	}
}
