//--- Textures For Space Rex    & CTDS shapes

#declare Gold3 = 
texture {  
	pigment { rgb <0.71, 0.65, 0.26> }
	finish {
		crand 0.02  
		ambient 0.2 
		diffuse 0.4 
		reflection 0.6 
		brilliance 8 
		specular 0.4 
	}
}

//--- Dark Metallic Steel
#declare HTex = 
texture {  
	pigment { DarkSlateGray }
	finish {
		crand 0.02  
		ambient 0.2 
		diffuse 0.5 
		reflection 0.6 
		brilliance 8 
		specular 0.4 
	}
}

#declare RayGunGreen = 
texture {  
	pigment { rgb <0.21, 0.65, 0.44> }
	finish {
		crand 0.02  
		ambient 0.2 
		diffuse 0.3 
		reflection 0.5 
		brilliance 6 
		specular 0.4 
	}
}

#declare LaserDust1 =
texture {
	pigment { Clear filter 0.99 }
	finish {
		ambient 1
		diffuse 0
	}
}
texture {
	pigment {
		gradient <1, 0, 0>
		color_map {
			[0.0, 0.6  color Yellow filter 0.5  color Clear]
			[0.6, 1.0  color Clear              color Clear]
		}
		scale <33, 1, 1>
	}
}
#declare LaserDust =
material {
	texture {
		LaserDust1
	}
	interior {
		//refraction 0.7
		ior 2
	}
}

#declare Laser =
texture {
	pigment { Red }
	finish {
		ambient 1
		diffuse 0.5
	}
}

#declare EarComm_Texture 	= texture { Gold3 }
#declare ArmBand_Texture 	= texture { Gold3 }
#declare Arm_Texture 		= texture { HTex }
#declare Elbow_Texture		= texture { Gold3 }
#declare Shoulder_Texture 	= texture { HTex }
#declare Knob_Texture 		= texture { Gold3 }
#declare Helmet_Texture		= texture { HTex }
#declare Neck_Texture 		= texture { Gold3 }
#declare NeckRing_Texture 	= texture { HTex }
#declare Harness_Texture	= texture { Gold3 }
#declare Chest_Texture 		= texture { HTex }
#declare Stomach_Texture 	= texture { HTex }
#declare EyeTexture 		= texture { HTex }
#declare Wire_Texture 		= texture { Gold3 }
#declare FM 			    = texture { Gold3 }
#declare HandTexture		= texture { Gold3 }

//--- CTDS Parts 
// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

#declare YourTexture = 
texture {
	pigment { red 0.556863 green 0.419608 blue 0.137255 }
	finish {
		ambient   0.1
		diffuse   0.6
		phong 1
	}
}

#declare Dot = quadric { <1, 1, 1>, <0, 0, 0>, <0, 0, 0>, -1 }

#declare Connector_1 = 
object {
	quadric {
		<0, 1, 1>, <0, 0, 0>, <0, 0, 0>, -1
	}
	clipped_by {
		plane { < 1, 0, 0>, 1 }
		plane { <-1, 0, 0>, 0 }
	}
}

#declare Connector_2 =
object {
	quadric { <1, -1, 1>, <0, 0, 0>, <0, 0, 0>, 0 }
	rotate <0, 0, 90>
}

#declare Connector_4 = 
intersection {
	quadric { <0, 1, 1>, <0, 0, 0>, <0, 0, 0>, -1 }
	plane { < 1, 0, 0>, 1 }
	plane { <-1, 0, 0>, 0 }
}
