//---- Rex on lost Planet W

//  Original file by Mike Miller
//
//  Modified for POV-Ray version 3.x by
//  Colin Fleming, cj_fleming@btinternet.com
//

//-------  Hazy Clouds
union {
	object { Sphere
		texture {
			pigment {
				gradient <0, 1, 0>
				color_map {
					[0.0, 0.2  color Gray  filter 0.7  color White filter 0.8]
					[0.2, 0.4  color White filter 0.8  color rgbf 1]
					[0.4, 1.0  color rgbf 1            color rgbf 1]

				}
				turbulence 0.7
				scale <1, 1, 1>
			}
			finish {
				ambient 1
				diffuse 0
			}
		}
		clipped_by {
			plane { <0, 0, 1>, 0.5 inverse }
		}
		scale <100000, 100000, 100000>
		rotate <0, 10, 0> //!!!
		rotate <0, 0, 195> //!!!
		translate <0, 800, 0>
		
	}
	object { Sphere
		texture {
			pigment {
				gradient <0, 1, 0>
				color_map {
					[0.0, 0.3  color SeaGreen                color rgb <0.05, 0.08, 0.12>]
					[0.3, 1.0  color rgb <0.05, 0.08, 0.12>  color Black]
				}
				scale <1, 0.5, 1>
			}
			finish {
				ambient 1
				diffuse 0
			}
		}
		clipped_by {
			plane { <0, 0, 1>, 0.5 inverse }
		}
		scale <200000, 200000, 200000>
		rotate <2, 0, 0> //!!!
		translate <0, 0, 0>
	}
	translate <0, -1000, 0>
}


//--- My first Moon....I should stop tracing naked
//--- Background Planet
union {
	object { Sphere
		texture { 
			pigment {
				bozo
				turbulence 0.4
				color_map {
					[0.0, 0.5  color Gray60  color Gray40]
					[0.5, 1.0  color Gray40  color Gray60]
				}
				scale 0.2
			}
			finish {
				ambient 0.5
				diffuse 0.2
				crand 0.05
			}
		}
		scale <8000, 8000, 8000>
		rotate <0, 0, 0>
		translate <0, 42000, 150000>
		rotate <0, -17, 0>
	}
	object { Sphere
		texture { 
			pigment {
				bozo
				turbulence 0.4
				color_map {
					[0.0, 0.5  color Clear             color White filter 0.6]
					[0.5, 1.0  color White filter 0.6  color Clear]
				}
				scale 0.5
			}
			finish {
				ambient 0.5
				diffuse 0.4
				crand 0.05
			}
		}
		scale <8500, 8500, 8500>
		rotate <0, 0, 0>
		translate <0, 42000, 150000>
		rotate <0, -17, 0>
	}
}


//++++++++++++++++++++++++++++++++++++++++++++++

//--- Water

//---- Water Overlay
#declare Water =
material {
	texture {
		pigment { rgbf <0.19, 0.22, 0.28, 0.95> }
		normal {
			ripples 0.01 
			frequency 0.03 
		}
		finish {
			reflection 0.3
			ambient 0.2
			diffuse 0.15
			phong 1
		}
	}
	interior {
		//refraction 1
		ior 1.5   
	}
}

//--- Rippley Water
union {

	plane { <0, 1, 0>, 590
		texture {
			pigment {
				image_map {
					//<-1, 0, 1>
					gif "ripple.gif"
					interpolate 4
				}
				//scale <1000, 1, 1000>
				rotate <90, 0, 180>
			}
			finish {
				ambient 0.7
				diffuse 0.7
			}
			scale <1000, 1, 1000>
		}
	}

	plane { <0, 1, 0>, 600
		material {
			Water
			translate <0, 600, -4000>
		}
	}
	
	translate <0, 50, 0>
	
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

//---- Rocky Ridge

//-----Translucent Grnt2
#declare Grnt2a =
texture {
	pigment {
		granite
		turbulence 0.6
		color_map {
			[0.000, 0.144   color rgbf <0.863, 0.757, 0.596, 0.596>   color rgbf <0.925, 0.792, 0.714, 0.349>]
			[0.144, 0.288   color rgbf <0.925, 0.792, 0.714, 0.349>   color rgbf <0.871, 0.702, 0.659, 0.784>]
			[0.288, 0.644   color rgbf <0.871, 0.702, 0.659, 0.784>   color rgbf <0.992, 0.922, 0.659, 0.498>]
			[0.644, 0.983   color rgbf <0.992, 0.922, 0.659, 0.498>   color rgbf <0.902, 0.812, 0.714, 0.722>]
			[0.983, 1.001   color rgbf <0.902, 0.812, 0.714, 0.722>   color rgbf <0.863, 0.757, 0.596, 0.596>]
		}
	}
}

//--------- filter Sand & light Orange
#declare Grnt15a =
texture {
	pigment {
		granite
		turbulence 0.6
		color_map {
			[0.000, 0.154   color rgbf <0.996, 0.824, 0.780, 0.412>   color rgbf <0.996, 0.698, 0.624, 0.412>]
			[0.154, 0.308   color rgbf <0.996, 0.698, 0.624, 0.412>   color rgbf <0.906, 0.675, 0.553, 0.616>]
			[0.308, 0.444   color rgbf <0.906, 0.675, 0.553, 0.616>   color rgbf <0.996, 0.682, 0.604, 0.412>]
			[0.444, 0.615   color rgbf <0.996, 0.682, 0.604, 0.412>   color rgbf <0.996, 0.824, 0.780, 0.412>]
			[0.615, 0.812   color rgbf <0.996, 0.824, 0.780, 0.412>   color rgbf <0.973, 0.627, 0.627, 0.600>]
			[0.812, 1.001   color rgbf <0.973, 0.627, 0.627, 0.600>   color rgbf <0.996, 0.824, 0.780, 0.412>]
		}
	}
}

/*--------------------Crack & OverTint /Red---------------------*/
#declare Crack1 =
texture {
	pigment {
		marble
		turbulence 0.85
		color_map {
			[0.00, 0.040  color Black   filter 0.6  color Black   filter 1.0]
			[0.04, 0.970  color Scarlet filter 0.8  color DimGray filter 0.9]
			[0.97, 1.001  color Black   filter 0.9  color Black   filter 1.0]
		}
	}
}

//------------- Rose & White Marble with dark tan swirl
#declare Stone11 =
//texture { pigment { Black } }
//texture { Grnt15a scale <1.2, 3, 1.5> rotate <70, 0, 30> finish { ambient 0.1 crand 0.03 } }
//texture { Grnt2a  scale <3, 3, 4>   rotate < 0, 0, 40> finish { ambient 0.1 } }
//texture { Crack1  scale <1, 2, 1.4> rotate <10, 0, -20> finish { ambient 0.1 } }
// the above is too "red"
texture { Crack1  scale <1, 2, 1.4> rotate <10, 0, -20> finish { ambient 0.1 } }
texture { Grnt2a  scale <3, 3, 4>   rotate < 0, 0, 40> finish { ambient 0.1 } }
texture { Grnt15a scale <1.2, 3, 1.5> rotate <70, 0, 30> finish { ambient 0.1 crand 0.03 } }

//#declare Stone11 = texture { pigment { Gray50 } }

//--- A Rock Gourge
object {
	height_field {
		tga "l7a.tga"  // flipped l7.tga horizontally
		water_level 0.02
		//smooth
		scale <10000, 2000, 10000>
		translate <-5000, 0, -5000>
	}
	texture {
		Stone11
		finish {
			phong 0.4
			phong_size 100
			ambient 0.6 //0.01
			diffuse 0.1
			crand 0.1
		}
		scale <500, 200, 200>
		rotate <0, 90, 180>
    }
	translate <0, -600, 0>
}

//--- Blue Reflect Panel
object {
	Square_Y
	scale <50000, 1, 50000>
	translate <0, 50000, -20000>
	texture {
		pigment { CadetBlue }
		finish {
			ambient 0.1
			diffuse 0.1
		}
	}
}
